<?php
/**
 * @package	SoftwareHtec.com Sendle Shipping
 * @version	1.1
 * @author	wp@softwarehtec.com
 * @homepage    http://www.softwarehtec.com
 * @copyright	(C) 2010-2017 SoftwareHtec.com. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgHikashopshippingplg_Softwarehtecsendle extends hikashopShippingPlugin {

	var $multiple = true;
	var $name = "plg_softwarehtecsendle";
	var $doc_form = "plg_softwarehtecsendle";
	var $use_cache = true;
	var $pluginConfig = array(
		'mode' => array('Sandbox Mode', 'boolean','0'),
		'api_id' => array('API Id', 'input'),
		'api_key' => array('API Key', 'input'),
		'pickup_suburb' => array('Pickup Suburb', 'input'),
		'pickup_postcode' => array('Pickup Postcode', 'input'),
		'plan_name' => array('Plan Name', 'list',array(
			'Default' => 'Default',
			'Easy' => 'Easy',
			'Premium' => 'Premium',
			'Pro' => 'Pro',
		)),
	);

	function processPackageLimit($limit_key, $limit_value, $product, $qty, $package, $units) {
		switch ($limit_key) {
			case 'volume':
				$divide = (float)($product['x'] * $product['y'] * $product['z']);
				if(empty($divide) || $divide > $limit_value)
					return false;
				return (int)floor($limit_value / $divide);
				break;
		}
		return parent::processPackageLimit($limit_key, $limit_value , $product, $qty, $package, $units);
	}

	function onShippingDisplay(&$order,&$dbrates,&$usable_rates,&$messages){

		if(!hikashop_loadUser())
			return false;

		$local_usable_rates = array();
		$local_messages = array();
		$ret = parent::onShippingDisplay($order, $dbrates, $local_usable_rates, $local_messages);
		if($ret === false)
			return false;


		if(!function_exists('curl_init')) {
			$app = JFactory::getApplication();
			$app->enqueueMessage('The Australia Sendle shipping plugin needs the CURL library installed but it seems that it is not available on your server. Please contact your web hosting to set it up.','error');
			return false;
		}

		$cache_usable_rates = array();
		$cache_messages = array();




		$currentCurrencyId = null;
		foreach($local_usable_rates as $rate) {

			$check = false;
			$db = JFactory::getDBO();
			if(is_array($order->shipping_address->address_country)) {
				$address_country = reset($order->shipping_address->address_country);
			} else {
				$address_country = $order->shipping_address->address_country;
			}
			$db->setQuery('SELECT * FROM '.hikashop_table('zone').' WHERE zone_namekey='.$db->Quote($address_country));
			$currentShippingZone = $db->loadObject();


			if($currentShippingZone->zone_code_3 != 'AUS') {
				$messages['no_shipping_to_your_zone'] = JText::_('NO_SHIPPING_TO_YOUR_ZONE');
				continue;
			}

			if(empty($order->shipping_address->address_post_code)) {
				$check = true;
				$message = 'The Australia Sendle shipping plugin requires the user to enter a postal code when goods are shipped within Australia. Please go to "Display->Custom fields" and set the post code field to required.';
			} elseif(!preg_match('#[0-9]{4}#',$order->shipping_address->address_post_code)) {
				$check = true;
				$message = 'The post code entered is not valid';
				$order->shipping_address->address_post_code = preg_replace('#[^0-9A-Z]#','',$order->shipping_address->address_post_code);
			}

			if($check) {
				$zoneClass=hikashop_get('class.zone');
				$zones = $zoneClass->getOrderZones($order);
				$db = JFactory::getDBO();
				$db->setQuery('SELECT zone_namekey FROM '.hikashop_table('zone').' WHERE zone_code_3='.$db->Quote('AUS'));
				$australia_zone = $db->loadResult();
				if(in_array($australia_zone,$zones)) {
					$cache_messages['post_code_missing'] = $message;
					continue;
				}
			}


			if(empty($order->shipping_address_full)) {
				$cart = hikashop_get('class.cart');
				if(isset($order->shipping_address->address_id))
					$cart->loadAddress($order->shipping_address_full, $order->shipping_address->address_id, 'object', 'shipping');
			}

			$this->getRates($rate, $order, $rates);

			foreach($rates as $finalRate) {
				$usable_rates[$finalRate->shipping_id]=$finalRate;
				$cache_usable_rates[$finalRate->shipping_id] = $finalRate;
			}
		}
		$this->setShippingCache($order, $cache_usable_rates, $cache_messages);

		if(!empty($cache_messages)) {
			foreach($cache_messages as $k => $msg) {
				$messages[$k] = $msg;
			}
		}
		return true;
	}

	function callSendleApi(&$rate, $order, $volume, $api, $packages ){

		if($volume > 0){
			$url = $api."/api/quote?pickup_suburb=".urlencode($rate->shipping_params->pickup_suburb)."&pickup_postcode=".urlencode($rate->shipping_params->pickup_postcode)."&kilogram_weight=".$packages["w"]."&cubic_metre_volume=".$volume."&delivery_suburb=".($order->shipping_address->address_suburb)."&delivery_postcode=".($order->shipping_address->address_post_code);
		}else{
			$url = $api."/api/quote?pickup_suburb=".urlencode($rate->shipping_params->pickup_suburb)."&pickup_postcode=".urlencode($rate->shipping_params->pickup_postcode)."&kilogram_weight=".$packages["w"]."&delivery_suburb=".($order->shipping_address->address_suburb)."&delivery_postcode=".($order->shipping_address->address_post_code);
		}
		if($rate->shipping_params->plan_name != "Default" ){
			$url .= "&plan_name=".$rate->shipping_params->plan_name;	
		}


		$session = curl_init();
		curl_setopt($session, CURLOPT_URL, $url );
		curl_setopt($session, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($session, CURLOPT_HTTPHEADER, array('Authorization: ' . 'Basic ' .  base64_encode( $rate->shipping_params->api_id . ':' . $rate->shipping_params->api_key )));
		curl_setopt($session, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($session, CURLOPT_SSL_VERIFYHOST,  2);
		$rawBody = curl_exec($session);
		curl_close($session);

		$result = json_decode( $rawBody ); // show target page

		return $result;
	}

	function getRates($rate, $order, &$rates) {
		$weightClass=hikashop_get('helper.weight');
		$volumeClass=hikashop_get('helper.volume');
		$limit = array();
		$domestic = 1;

		if(@$order->shipping_address_full->shipping_address->address_country->zone_code_2 != 'AU') {
			return false;
		}

		if(empty($currentCurrencyId)) {
			$query = 'SELECT currency_id FROM '.hikashop_table('currency').' WHERE currency_code=\'AUD\'';
			$db = JFactory::getDBO();
			$db->setQuery($query);
			$currentCurrencyId = $db->loadResult();
		}

		$packages = $this->getOrderPackage($order, array('weight_unit' => 'kg', 'volume_unit' => 'm',  'required_dimensions' => array('w','x','y','z')));

		if(empty($packages))
			return true;

		$api = "";

		if($rate->shipping_params->mode == 0){
			$api = "https://api.sendle.com";
		}else{
			$api = "https://sandbox.sendle.com";
		}

		if(isset($packages['x']) && isset($packages['y']) && isset($packages['z'])){
			if($packages["w"] > 25 || $packages["w"] == 0)
				return true;

			$volume = $packages["x"] * $packages["y"] * $packages["z"];


			if($volume > 0.1 && !empty($volume))
				return true;

			$result = $this->callSendleApi($rate, $order, $volume, $api,$packages );

			$this->addRate($rates,$rate,$currentCurrencyId,$result);
		}else{
			foreach($packages as $package) {
				if(isset($package['x']) && isset($package['y']) && isset($package['z'])){
					if($package["w"] > 25 || $package["w"] == 0)
						continue;

					$volume = $package["x"] * $package["y"] * $package["z"];

					if($volume > 0.1 && !empty($volume))
						continue;

					$result = $this->callSendleApi($rate, $order, $volume, $api,$package );

					$this->addRate($rates,$rate,$currentCurrencyId,$result);

				}
			}
		}
	}

	function onShippingConfigurationSave(&$element) {
		$app = JFactory::getApplication();

		if(empty($element->shipping_params->api_id))
			$app->enqueueMessage(JText::sprintf('ENTER_INFO', 'Australia Sendle', "API Id"));
		if(empty($element->shipping_params->api_key))
			$app->enqueueMessage(JText::sprintf('ENTER_INFO', 'Australia Sendle', "API Key"));
		if(empty($element->shipping_params->pickup_suburb))
			$app->enqueueMessage(JText::sprintf('ENTER_INFO', 'Australia Sendle', "Pickup Suburb"));
		if(empty($element->shipping_params->pickup_postcode))
			$app->enqueueMessage(JText::sprintf('ENTER_INFO', 'Australia Sendle', "Pickup Postcode"));


		parent::onShippingConfigurationSave($element);
	}

	function getShippingDefaultValues(&$element) {
		$element->shipping_name = 'Australia Sendle';
		$element->shipping_description = '';
		$element->shipping_images = 'softwarehtecsendle';

		$element->shipping_params->api_id = '';
		$element->shipping_params->api_key = '';
		$element->shipping_params->pickup_suburb = '';
		$element->shipping_params->pickup_postcode = '';
		$element->shipping_params->plan_name = '';
		$elements = array($element);
	}


	function onShippingConfiguration(&$element) {

		$db = JFactory::getDBO();
		$db->setQuery('SELECT * FROM '.hikashop_table('field').' WHERE field_table="address" and field_namekey="address_suburb"');
		$suburb = $db->loadObject();


		if(!$suburb){

			$query = $db->getQuery(true);
			$fieldcolumns = array('field_table', 'field_realname', 'field_namekey', 'field_type','field_published','field_ordering','field_options','field_core','field_required','field_access','field_categories','field_with_sub_categories','field_frontcomp','field_backend','field_backend_listing');
			$fieldvalues = array('address','Suburb','address_suburb','text',1,99,'a:15{s:12:"errormessage";s:0:"";s:5:"regex";s:0:"";s:9:"attribute";s:0:"";s:11:"placeholder";s:0:"";s:6:"inline";s:1:"0";s:4:"cols";s:0:"";s:9:"filtering";s:1:"1";s:9:"maxlength";s:1:"0";s:4:"rows";s:0:"";s:9:"zone_type";s:7:"country";s:12:"pleaseselect";s:1:"0";s:4:"size";s:0:"";s:6:"format";s:8:"%Y-%m-%d";s:5:"allow";s:0:"";s:8:"readonly";s:1:"0";}','0','1','all','all','0','1','1','0');

			$query->insert(hikashop_table('field'))->columns($db->quoteName($fieldcolumns ))->values("'".implode('\',\'', $fieldvalues )."'");
			$db->setQuery($query);
			$db->execute();

			$columns = $db->getTableColumns(hikashop_table('address'));
			if(!isset($columns["address_suburb"])){
				$query = "ALTER TABLE `".hikashop_table('address')."` ADD `address_suburb` VARCHAR(255) NOT NULL AFTER `address_id`; ";
                                $db->setQuery($query);
				$db->execute();
			}
		}


		$jinput   = JFactory::getApplication()->input;

		$this->softwarehtecsendle = $jinput->getCmd('name','plg_softwarehtecsendle');
		$this->categoryType = hikashop_get('type.categorysub');
		$this->categoryType->type = 'tax';
		$this->categoryType->field = 'category_id';

		parent::onShippingConfiguration($element);
	}


	function addRate(&$rates,&$rate,$currentCurrencyId,$result) {

		if(!isset($result->error)){
			if(count($result) > 0){
				foreach($result as $k => $r){
					$service_code = "sendle-".$k ;

					if(empty($rates[$service_code])) {
						$info = new stdClass();
						$info = (!HIKASHOP_PHP5) ? $rate : clone($rate);
						$info->shipping_name = "Australia Sendle ( ".$r->plan_name." )";

						if (!empty($rate->shipping_description))
							$info->shipping_description = $rate->shipping_description . ' ';
						$info->shipping_id = $k;
						$rates[$service_code]=$info;
					}
	
					$rates[$service_code]->shipping_price += $r->quote->gross->amount;
					$rates[$service_code]->shipping_currency_id = $currentCurrencyId ;

				}
			}
		}
	}

	function shippingMethods(&$main) {
		$methods = array();

		foreach($this->shipping_types as $value => $key){
			if(!empty($main->shipping_params->$value))
				$methods[$main->shipping_id.'-'.$key] = $this->shipping_names[$value];
		}

		return $methods;
	}

}